//
//  NGAConditionalExecutor.h
//  P4Menu
//
//  Created by Michael Bishop on 9/29/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

// This is a utility for executing code only if specified attributes of an object are unchanged.
//
// To use it, you specify the "signature" attributes and the object that contains them. after that, calling conditionallyExecuteBlock will only succeed if those attributes remain unchanged.


@interface NGAConditionalExecutor : NSObject {
    @private
    NSDictionary * _values;
    NSArray        * _keypaths;
    __weak id      _object;
}

+(id)executorWithConditionalKeyPaths:(NSArray*)keypaths object:(id)object;

-(id)initWithConditionalKeyPaths:(NSArray*)keypaths object:(id)object;

-(BOOL)conditionallyExecuteBlock:(void(^)())block;

@end
